document.addEventListener("DOMContentLoaded", function() {


    // Global variable
    window.compareListId = [];

    // access DOM
    
    const compareItemButtonDOM = document.getElementsByClassName("compare-product");
    const containerCompareDOM = document.getElementsByClassName("container-compare")[0];
    const compareButtonDOM = document.getElementsByClassName("compare")[0];
    const compareCanvasDOM = document.getElementsByClassName("compare-page")[0];
    const compareCanvasCloseDOM = document.getElementById("close-compare-page");
    

    // other property
    let requestLock = false;
    let compareCounter = 0;



    for(var i=0;i<compareItemButtonDOM.length;i++){
        const currentElement = compareItemButtonDOM[i];
        currentElement.addEventListener("click" , handlerCompareProduct);
    }

    compareButtonDOM.addEventListener("click" , handlerCompareButton);
    compareCanvasCloseDOM.addEventListener("click" , handlerCloseComparePage);

    // Handlers

    function handlerCompareProduct(event){
        const thisElement = event.target;
        const productID = thisElement.getAttribute("data-id");

        if(thisElement.getAttribute("compare-status") == "true"){
            for(var i=0;i<window.compareListId.length;i++){
                const currentIndex = window.compareListId[i];
                if(productID == currentIndex){
                    window.compareListId.splice(i , 1);
                    break;
                }
            }
            thisElement.setAttribute("compare-status" , "false");
            thisElement.removeAttribute("style");
            changeCompareButtonText();
            return;
        }

        
        window.compareListId.push(productID);
        thisElement.setAttribute("compare-status" , "true");
        thisElement.style.background = "tomato";
        changeCompareButtonText();
        return
    }

    function handlerCompareButton(event){
        
        
        
        compareCanvasDOM.classList.add("page-active");

        if(0 < window.compareListId.length && window.compareListId[compareCounter]){
            customGetRequestFunc({
                params : {
                    "pid" : window.compareListId[compareCounter]
                },
                loadFunc : function(){
                    requestLock = false;
                    const response = this.response;
                    
                    if(response.status == 0){
                        alert(response.msg);
                        return 0;
                    }

                    const data = response.data;
                    
                    const htmlContent = generateHtmlElementFunc(data);
                   
                    containerCompareDOM.innerHTML += htmlContent;
                    //window.compareListId.shift();
                    compareCounter++;
                    handlerCompareButton();
                },
            });
            
        }else if(containerCompareDOM.innerHTML == ""){
            alert("موردی یافت نشد");
        }

    }

    function handlerCloseComparePage(event){
        const thisElement = event.target; 
        containerCompareDOM.innerHTML = "";
        thisElement.parentElement.classList.remove("page-active");
        compareCounter = 0;
    }
   

    

    // ajax request

    function customGetRequestFunc(options) {
        if(requestLock == true)
            return;

        const xhr = new XMLHttpRequest();
        xhr.responseType = "json";

        requestLock = true;

        let queryString = new URLSearchParams;

        const params = options.params;
        for (const param in params) {
            queryString.append(param, params[param]);
        }

        
        queryString = "?" + queryString.toString();
        xhr.open("GET", location.href + "/compare.php" + queryString);

        xhr.onload = options.loadFunc;

        xhr.onerror = function() {
            requestLock = false;
            console.warn("[XHR Error]");
        }

        xhr.send();
    }


    // other

    function getFeatureKeys(){
        return {
            "dimension" : "ابعاد",
            "weight" : "وزن" ,
            "specialFeatures" : "ویژگی های خاص",
            "numSimcard" : "تعداد سیمکارت",
            "internalStorage" : "حافظه داخلی",
            "pictureResolution" : "رزولوشن دوربین",
            "selfieResolution" : "رزولوشن سلفی",
            "videoRecording" : "فیلمبرداری"
        };
    }

    function generateHtmlElementFunc(data) {
        const features = JSON.parse(data.features);
        const featuresDbKey = Object.keys(features);
        
        const featureKeys = getFeatureKeys();
        let tableRows = "";
        for(var i=0;i<featuresDbKey.length;i++){
            let currentKey = featuresDbKey[i];
            const currentIndex = features[currentKey];
            currentKey = featureKeys[currentKey];
            tableRows += `<tr><td>${currentKey}</td><td>${currentIndex}</td></tr>`;
        }

        const templateHtml = `<article id="pid-${data.id}"><img src="${data.thumbnail}" alt="${data.title}"><h2>${data.title}</h2><table>${tableRows}</table><span id="price">${data.price} تومان</span><br></article>`;
        return templateHtml;
    }

    function changeCompareButtonText(){
        compareButtonDOM.textContent = window.compareListId.length;
        compareButtonDOM.textContent = (compareButtonDOM.textContent == "0") ? "?" : compareButtonDOM.textContent;
    }



});